using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Api
{
    [UnmanagedFunctionPointerAttribute(CallingConvention.StdCall, CharSet = CharSet.Unicode)]
    public delegate void exportViplexCallback(int code, string data);

    class ApiTester
    {
        [DllImport("viplexcore.dll", EntryPoint = "nvInitW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern int NvInitW(byte[] sdkRootDir, byte[] credentials);

        [DllImport("viplexcore.dll", EntryPoint = "nvSearchTerminalAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSearchTerminalAsyncW(exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDownloadTerminalPlayLogAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDownloadTerminalPlayLogAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDownloadTerminalAllLogAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDownloadTerminalAllLogAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvCancelFunctionAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvCancelFunctionAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvCheckNetworkAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvCheckNetworkAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvUploadTerminalLogAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvUploadTerminalLogAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDownloadTerminalLogAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDownloadTerminalLogAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetTimeZoneAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetTimeZoneAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetTokenAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetTokenAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvIsExistPlayerNameAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvIsExistPlayerNameAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetPlayerIdentiferAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetPlayerIdentiferAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvIsCommonCloudAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvIsCommonCloudAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvFinishDataAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvFinishDataAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvStartGetAvailableMemoryDataAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvStartGetAvailableMemoryDataAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvUploadFeedBackFileStateAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvUploadFeedBackFileStateAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvUploadFeedbackInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvUploadFeedbackInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvAddNodeServerInfoListAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvAddNodeServerInfoListAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvChangeNodeServerListAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvChangeNodeServerListAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDeleteNodeServerListAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDeleteNodeServerListAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvAddNodeServerListAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvAddNodeServerListAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetNodeServerListAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetNodeServerListAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetAudioMedioProgramAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetAudioMedioProgramAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetFileMD5AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetFileMD5AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetCustomerTplAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetCustomerTplAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvStopProgramTransferAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvStopProgramTransferAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvStartTransferProgramAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvStartTransferProgramAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDeleteProgramAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDeleteProgramAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetProgramAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetProgramAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDeleteTplAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDeleteTplAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvEditTplAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvEditTplAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvAddTplAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvAddTplAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetSystemTplInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetSystemTplInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvMakeProgramAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvMakeProgramAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetPageProgramAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetPageProgramAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvCreateProgramAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvCreateProgramAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvQueryFileByTypeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvQueryFileByTypeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDownLoadFilesAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDownLoadFilesAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDataBaseMigrationAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDataBaseMigrationAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetScreenUnitTempAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetScreenUnitTempAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetScreenShotAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetScreenShotAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetTimeAndZoneAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetTimeAndZoneAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetDisplayInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetDisplayInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetRotationAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetRotationAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetRotationAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetRotationAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDownLoadScreenshotAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDownLoadScreenshotAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetIsUseDayLightTimeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetIsUseDayLightTimeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvAddNetTimingInfoListAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvAddNetTimingInfoListAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvUpdateNetTimingInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvUpdateNetTimingInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDeleteNetTimingInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDeleteNetTimingInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvAddNetTimingInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvAddNetTimingInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetNetTimingListInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetNetTimingListInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetNetTimingInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetNetTimingInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetNetTimingInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetNetTimingInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvCalibrateTimeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvCalibrateTimeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetCurrentTimeAndZoneAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetCurrentTimeAndZoneAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetMonitorInfoByReceiverIndexAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetMonitorInfoByReceiverIndexAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetReceiverCountAndInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetReceiverCountAndInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetSendCardMonitorInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetSendCardMonitorInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetAvailableMemoryAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetAvailableMemoryAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetCPUTempAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetCPUTempAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetCPUUsageAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetCPUUsageAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetAvailableStorageDataAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetAvailableStorageDataAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetBindPlayerAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetBindPlayerAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetCloudPlayerListAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetCloudPlayerListAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetBindPlayerAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetBindPlayerAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetIcareConfigInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetIcareConfigInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetIcareConfigInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetIcareConfigInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetRecvCardFileAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetRecvCardFileAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetScreenAttributeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetScreenAttributeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetScreenAttributeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetScreenAttributeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetModuleInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetModuleInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetWifiApStationSwitchAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetWifiApStationSwitchAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetAPNetworkOpenStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetAPNetworkOpenStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetAPNetworkOpenStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetAPNetworkOpenStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGet4GNetworkStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGet4GNetworkStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetFlightModeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetFlightModeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetFlightModeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetFlightModeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetAPNInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetAPNInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetAPNInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetAPNInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetAPNetworkAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetAPNetworkAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetAPNetworkAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetAPNetworkAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetEthernetInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetEthernetInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetEthernetInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetEthernetInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvIsMobileModuleExistedAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvIsMobileModuleExistedAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetMobileNetworkAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetMobileNetworkAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetMobileNetworkAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetMobileNetworkAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSendForgetWifiCommandAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSendForgetWifiCommandAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetWifiEnabledAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetWifiEnabledAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetWifiEnabledAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetWifiEnabledAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDisconnectWifiNetworkAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDisconnectWifiNetworkAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetWifiCurrentStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetWifiCurrentStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvConnectWifiNetworkAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvConnectWifiNetworkAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetWifiListAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetWifiListAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvUpdateVerifyAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvUpdateVerifyAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDeleteCollectorAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDeleteCollectorAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvAddCollectorAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvAddCollectorAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetPickerReceiverAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetPickerReceiverAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetCustomResolutionAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetCustomResolutionAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetHdmiOutputStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetHdmiOutputStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetHdmiOutputStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetHdmiOutputStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetReBootTaskAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetReBootTaskAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetReBootTaskAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetReBootTaskAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetSupportedResolutionAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetSupportedResolutionAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetCurrentResolutionAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetCurrentResolutionAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetCurrentResolutioAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetCurrentResolutioAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetOTGUSBModeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetOTGUSBModeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetOTGUSBModeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetOTGUSBModeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvClearAllMediasAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvClearAllMediasAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetReBootWipeUserDataAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetReBootWipeUserDataAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetSyncPlayAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetSyncPlayAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetSyncPlayAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetSyncPlayAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvStopPlayAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvStopPlayAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvResumePlayAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvResumePlayAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvPausePlayAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvPausePlayAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvStartPlayAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvStartPlayAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDeletePlayListAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDeletePlayListAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetProgramInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetProgramInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetScreenPowerPolicyFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetScreenPowerPolicyFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetScreenPowerManual0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetScreenPowerManual0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvsetScreenPowerPolicy0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvsetScreenPowerPolicy0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvsetScreenPowerManual0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvsetScreenPowerManual0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetScreenPowerPolicyAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetScreenPowerPolicyAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetScreenPowerPolicyAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetScreenPowerPolicyAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetScreenPowerStateAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetScreenPowerStateAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetScreenPowerStateAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetScreenPowerStateAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetScreenPowerModeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetScreenPowerModeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetScreenPowerModeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetScreenPowerModeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetColorTemperatureAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetColorTemperatureAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetColorTemperatureAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetColorTemperatureAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvgetPolicyBrightnessFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvgetPolicyBrightnessFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvsetPolicyBrightnessFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvsetPolicyBrightnessFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvsetManualBrightnessFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvsetManualBrightnessFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetEnvironmentBrightnessAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetEnvironmentBrightnessAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetBrightnessPolicyAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetBrightnessPolicyAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetBrightnessPolicyAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetBrightnessPolicyAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetScreenBrightnessAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetScreenBrightnessAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetScreenBrightnessAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetScreenBrightnessAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetBrightnessAdjustModeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetBrightnessAdjustModeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetBrightnessAdjustModeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetBrightnessAdjustModeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetconfigurationAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetconfigurationAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetProductInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetProductInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetInstalledPackageVersionsAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetInstalledPackageVersionsAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetFirmwareInfosAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetFirmwareInfosAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvLogoutAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvLogoutAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetSystemInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetSystemInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetTerminalInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetTerminalInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetTerminalInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetTerminalInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetScreenInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetScreenInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDelTerminalInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDelTerminalInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvChangePassWordAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvChangePassWordAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvLoginAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvLoginAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvFindAllTerminalsAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvFindAllTerminalsAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSearchRangeIpAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSearchRangeIpAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSearchAppointIpAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSearchAppointIpAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetUserInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetUserInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetUserInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetUserInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetVideoSourcePolicyFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetVideoSourcePolicyFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetVideoSourcePolicyFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetVideoSourcePolicyFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetVideoSourceManualFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetVideoSourceManualFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetVideoSourceManualFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetVideoSourceManualFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetVideoEDIDAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetVideoEDIDAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetVideoEDIDAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetVideoEDIDAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetVideoControlInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetVideoControlInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetVideoControlInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetVideoControlInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetRelayPowerStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetRelayPowerStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetRelayPowerStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetRelayPowerStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetRelayPowerPolicyAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetRelayPowerPolicyAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetRelayPowerPolicyAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetRelayPowerPolicyAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetRelayPowerManualAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetRelayPowerManualAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetPowerModeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetPowerModeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetPowerModeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetPowerModeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetPowerInfoStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetPowerInfoStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetPowerInfoPolicyAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetPowerInfoPolicyAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetPowerInfoPolicyAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetPowerInfoPolicyAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetPowerInfoManualAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetPowerInfoManualAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetLoraInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetLoraInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetSupportSensorInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetSupportSensorInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetSupportSensorInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetSupportSensorInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetSpliceInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetSpliceInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetSpliceInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetSpliceInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvUpdateFontAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvUpdateFontAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvDeleteFontAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvDeleteFontAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetTerminalFontAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetTerminalFontAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetPlaylogPathAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetPlaylogPathAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvStartUploadApkCoreAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvStartUploadApkCoreAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvUninstallPackageAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvUninstallPackageAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvForceStopAppAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvForceStopAppAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetRunningPackageInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetRunningPackageInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetInstalledPackageInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetInstalledPackageInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetVPNConnectInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetVPNConnectInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetVPNConnectInfoAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetVPNConnectInfoAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetTimingVolumeFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetTimingVolumeFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetTimingVolumeFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetTimingVolumeFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetVolumeFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetVolumeFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetVolumeFor0x99AsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetVolumeFor0x99AsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetTimingVolumeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetTimingVolumeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetTimingVolumeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetTimingVolumeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetVolumeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetVolumeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetVolumeAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetVolumeAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetManualPowerSwitchStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetManualPowerSwitchStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetManualPowerSwitchStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetManualPowerSwitchStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetRealtimePowerSwitchStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetRealtimePowerSwitchStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvGetTimingPowerSwitchStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvGetTimingPowerSwitchStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        [DllImport("viplexcore.dll", EntryPoint = "nvSetTimingPowerSwitchStatusAsyncW", CharSet = CharSet.Unicode, CallingConvention = CallingConvention.Cdecl)]
        public static extern void NvSetTimingPowerSwitchStatusAsyncW(byte[] data, exportViplexCallback resultCallback);

        


    }
}